do
local UpgInterface = import('/mods/SupremilatedATWMedia_104/upgradeinterface.lua')
local originalCreateUI = CreateUI
local originalOnSelectionChanged = OnSelectionChanged

function CreateUI(isReplay)
    originalCreateUI(isReplay)
    ConExecute("cam_nearzoom 2")

    local mykeytable = {    ['X']              = {action =  'StartCommandMode order RULEUCC_Teleport', stringkey = 'teleport', category = '<LOC keymap_category_0036>Orders', order = 16,}, } 
    IN_AddKeyMapTable(mykeytable)
end
function OnSelectionChanged(oldSelection, newSelection, added, removed)
    originalOnSelectionChanged(oldSelection, newSelection, added, removed)
    --check, is this unit a quantum factory? then replace the upgrade button
    local foundGate = false
    for i, unit in newSelection do
        if unit:IsInCategory('GATE') then
            UpgInterface.CreateButton(unit)
            foundGate = true
            break
        end
    end
    if not foundGate then
        if UpgInterface.MainButton then
            UpgInterface.MainButton:Destroy()
            UpgInterface.MainButton = false
        end
    end
end
end