do
local OldProjectile = CDFProtonCannon03 
CDFProtonCannon03 = Class(OldProjectile) { 
    OnImpact = function(self, targetType, targetEntity)
        local army = self:GetArmy()
        CreateLightParticle( self, -1, army, 3, 12, 'glow_03', 'ramp_red_06' )
        CreateLightParticle( self, -1, army, 2, 22, 'glow_03', 'ramp_antimatter_02' )
        if targetType == 'Terrain' or targetType == 'Prop' then
            CreateSplat( self:GetPosition(), 0, 'scorch_011_albedo', 2, 2, 350, 200, army )
        end
        ForkThread(self.ForceThread, self, self:GetPosition())
        OldProjectile.OnImpact(self, targetType, targetEntity)
    end,
    ForceThread = function(self, pos)
        DamageArea(self, pos, 2, 1, 'Force', true)
        WaitTicks(2)
        DamageArea(self, pos, 2, 1, 'Force', true)
        DamageRing(self, pos, 2, 3, 1, 'Fire', true)
    end,
}
TypeClass = CDFProtonCannon03
end