#
# Cybran Artillery Projectile
#
do
local CArtilleryProtonProjectile = import('/lua/cybranprojectiles.lua').CArtilleryProtonProjectile
OldClass = CIFArtilleryProton01
CIFArtilleryProton01 = Class(OldClass) {
    OnImpact = function(self, targetType, targetEntity)
        CArtilleryProtonProjectile.OnImpact(self, targetType, targetEntity)
        local army = self:GetArmy()
        CreateLightParticle( self, -1, army, 24, 12, 'glow_03', 'ramp_red_06' )
        CreateLightParticle( self, -1, army, 8, 22, 'glow_03', 'ramp_antimatter_02' )
        if targetType == 'Terrain' or targetType == 'Prop' then
            CreateSplat( self:GetPosition(), 0, 'scorch_011_albedo', 5, 5, 350, 200, army )
        end
        ForkThread(self.ForceThread, self, self:GetPosition())
        self:ShakeCamera( 20, 1, 0, 1 )        
    end,

}
TypeClass = CIFArtilleryProton01
end
