do

local OldUnit = UAB1102
UAB1102 = Class(OldUnit) 
{ 

    DefaultEnergy = 0,
    EnergyYield = 0,
    SmokeScaleMultiplier = 0.125,
    SmokeScale = 0,
    SmokeScaleBase = 1,
    EffectOffset = { x=0, y=-.2, z=1},

    OnStopBeingBuilt = function(self, builder, layer)
        OldUnit.OnStopBeingBuilt(self, builder, layer) 
        self.AgeManagerThread = self:ForkThread(self.AgeManager)
        self.DefaultEnergy = self:GetBlueprint().Economy.ProductionPerSecondEnergy
        self.EnergyYield = self.DefaultEnergy
    end,

    AgeManager = function(self)
        while not self:IsDead() and self.EnergyYield < 2000 do
            --LOG("|| " .. self.EnergyYield)
            self.EnergyYield = self.EnergyYield + 1
            self:UpdateProductionValues()
--[[        This code doesn't work yet.
            if math.mod(self.EnergyYield,20) == 0 then
                local Multiplier = 1 + (self.EnergyYield / self.DefaultEnergy * self.SmokeScaleMultiplier)
                LOG("|| Effect Scale: " .. Multiplier)
                self.SmokeScale = self.SmokeScaleBase * Multiplier
                self.EffectLODCutoff = 50 + (20 * (self.SmokeScale / self.SmokeScaleBase))
                self:AddEffects()
            end
--]]
            WaitSeconds(2)
        end
        self.EnergyYield = 2000
            self:UpdateProductionValues()
    end,

    AddEffects = function(self)
        self:DestroyEffects()
        local effects = {}
        local bones = {}
        effects = self.AirEffects
        bones = self.AirEffectsBones
        for keffects, veffects in effects do
            for kbones, vbones in bones do
                table.insert(self.EffectsBag,CreateAttachedEmitter(self,vbones,self:GetArmy(), veffects)
                :ScaleEmitter(self.SmokeScale)
                :OffsetEmitter(self.EffectOffset.x,self.EffectOffset.y,self.EffectOffset.z)
                :SetEmitterParam('LODCutoff', self.EffectLODCutoff))
            end
        end
    end,
    DestroyEffects = function(self)
        if self.EffectsBag then 
            for keys,values in self.EffectsBag do
                values:Destroy()
            end
        end
        self.EffectsBag = {}
    end,    

} 

TypeClass = UAB1102

end
