do
local OldUnit = UEB1301
UEB1301 = Class(OldUnit) { 
    OnStopBeingBuilt = function(self, builder, layer)
        OldUnit.OnStopBeingBuilt(self, builder, layer) 
        if self:GetCurrentLayer() == 'Seabed' then
            local EconBP = self:GetBlueprint().Economy
            local UnderwaterProductionFactor = EconBP.UnderwaterProductionFactor or 1
            self:SetProductionPerSecondEnergy(EconBP.ProductionPerSecondEnergy * UnderwaterProductionFactor)
        end
    end,
}
TypeClass = UEB1301
end


--[[
do

local OldUnit = UEB1301
local Unit = import('/lua/sim/Unit.lua').Unit

UEB1301 = Class(OldUnit) { 
    OnStopBeingBuilt = function(self, builder, layer)
        OldUnit.OnStopBeingBuilt(self, builder, layer) 
        self:SetScriptBit('RULEUTC_CloakToggle', true)
        if self:GetCurrentLayer() == 'Seabed' then
            local EconBP = self:GetBlueprint().Economy
            local UnderwaterProductionFactor = EconBP.UnderwaterProductionFactor or 1
            self:SetProductionPerSecondEnergy(EconBP.ProductionPerSecondEnergy * UnderwaterProductionFactor)
            self:RemoveToggleCap('RULEUTC_CloakToggle')
        end
        self:SetMaintenanceConsumptionInactive()
        self:DisableUnitIntel('Cloak')
        self:RequestRefreshUI()
        self.RecloakCountdown = 0
        self.CloakManagerThread = self:ForkThread(self.CloakManager)
    end,

    Cloak = function(self)
        if not(self:IsIntelEnabled('Cloak')) then 
            self:EnableUnitIntel('Cloak')
            self:DestroyVeteranEmitter()
            if self.EnergySwitch then
                self.EnergySwitch.Cloak = true
                self:UpdateEnergyUsage()
            else
                self:SetMaintenanceConsumptionActive()
            end
            self:SetProductionPerSecondEnergy(0)
        end
    end,

    Decloak = function(self)
        if self:IsIntelEnabled('Cloak') then 
            self:DisableUnitIntel('Cloak')
            self:CreateVeteranEmitter()
            if self.EnergySwitch then
                self.EnergySwitch.Cloak = false
                self:UpdateEnergyUsage()
            else
                self:SetMaintenanceConsumptionInactive()
            end
            self:SetProductionPerSecondEnergy(self:GetBlueprint().Economy.ProductionPerSecondEnergy)
        end
    end,
}

TypeClass = UEB1301

end
--]]