do

local OldUnit = UEB2401
UEB2401 = Class(OldUnit) {
    Weapons = {
        MainGun = Class(OldUnit.Weapons.MainGun) {
            CreateProjectileAtMuzzle = function(self, muzzle)
                local proj = OldUnit.Weapons.MainGun.CreateProjectileAtMuzzle(self, muzzle)
                local data = {
                    Radius = self:GetBlueprint().CameraVisionRadius or 15,
                    Lifetime = self:GetBlueprint().CameraLifetime or 15,
                    Army = self.unit:GetArmy(),
                }
                if proj and not proj:BeenDestroyed() then
                    proj:PassData(data)
                end
            end, -- CreateProjectileAtMuzzle
        }, -- MainGun
    }, -- Weapons
} -- UEB2401

TypeClass = UEB2401

end
