do

local OldUnit = UEL0303
UEL0303 = Class(OldUnit) {
    EnableSpecialToggle = function(self)
        OldUnit:EnableSpecialToggle()
        if self.SpeedThread then
            self.SpeedThread:Destroy()
        end
        self.SpeedThread = self:ForkThread(self.EngageSpeedMode)
    end,
    DisableSpecialToggle = function(self)
        OldUnit:DisableSpecialToggle()
        if self.SpeedThread then
            self.SpeedThread:Destroy()
        self:DisengageSpeedMode()
        end
    end,
    EngageSpeedMode = function(self)
        self:RemoveCommandCap('RULEUCC_Attack')
        self:SetWeaponEnabledByLabel('HeavyPlasma01', false)
        self:SetSpeedMult(3)
        self:SetTurnMult(0.25)
        WaitSeconds(15)
        self:DisengageSpeedMode()
    end,
    Recharge = function(self)
        self:RemoveToggleCap('RULEUTC_SpecialToggle')
        WaitSeconds(45)
        self:AddToggleCap('RULEUTC_SpecialToggle')
        self:SetScriptBit('RULEUTC_SpecialToggle', false)
    end,
    DisengageSpeedMode = function(self)
        self:SetSpeedMult(1)
        self:SetTurnMult(1)
        self:SetWeaponEnabledByLabel('HeavyPlasma01', true)
        self:AddCommandCap('RULEUCC_Attack')
        self:ForkThread(self.Recharge)
    end,
}

TypeClass = UEL0303

end
