do
local OldWeapon = Weapon
Weapon = Class(OldWeapon) {

    GetDamageTable = function(self)
        local weaponBlueprint = self:GetBlueprint()
        local damageTable = OldWeapon.GetDamageTable(self)
        damageTable.EdgeDamageRatio = weaponBlueprint.EdgeDamageRatio
        return damageTable
    end,

    SetTurretPitchSpeed = function(self, speed)
        local turretyawmin, turretyawmax = self:GetTurretYawMinMax()
        local turretpitchmin, turretpitchmax = self:GetTurretPitchMinMax()
        local turretyawspeed = self:GetTurretYawSpeed()
        if self.AimControl then
            self.AimControl:SetFiringArc(turretyawmin, turretyawmax, turretyawspeed, turretpitchmin, turretpitchmax, speed)
        end
    end,

} TypeClass = Weapon
end
