do
    local oldUpdateVetIcons = UpdateVetIcons
    function UpdateVetIcons(level, faction)
        #We are going to overwrite the passed in level
        local bp = __blueprints[rolloverInfo.blueprintId]
        local vetLevels = {[5] = 1000,
            [4] = 500,
            [3] = 250,
            [2] = 100,
            [1] = 25,
            [0] = 0,
        }
        if bp.Veteran then
            vetLevels[5] = bp.Veteran['Level5']
            vetLevels[4] = bp.Veteran['Level4']
            vetLevels[3] = bp.Veteran['Level3']
            vetLevels[2] = bp.Veteran['Level2']
            vetLevels[1] = bp.Veteran['Level1']
        end
        local KillCredit = UnitData[rolloverInfo.entityId].KillCredit or 0
        if(KillCredit >= vetLevels[5]) then
            level = 5
        elseif(KillCredit >= vetLevels[4]) then
            level = 4
        elseif(KillCredit >= vetLevels[3]) then
            level = 3
        elseif(KillCredit >= vetLevels[2]) then
            level = 2
        elseif(KillCredit >= vetLevels[1]) then
            level = 1
        else
            level = 0
        end
        
        if(level < 5) then
            local levelProgress = (KillCredit - (vetLevels[level]))/((vetLevels[level + 1])-(vetLevels[level]))
    --          LOG("*debug: Kill Credit: " .. KillCredit)
    --          LOG("*debug: Kills Required: " .. vetLevels[level])
    --         LOG("*debug: Level Progress:" .. levelProgress)
            controls.vetProgBar:SetValue(levelProgress)
        else
            controls.vetProgBar:SetValue(1)
        end
        oldUpdateVetIcons(level,faction)
    end

    local oldSetLayout = SetLayout
    function SetLayout(layout)
        oldSetLayout(layout)
        if not controls.vetProgBar then
            controls.vetProgBar = StatusBar(controls.roBG, 0, 1, true, false, '/mods/SupremilatedATWMedia_104/textures/vet-bar_back.dds', '/mods/SupremilatedATWMedia_104/textures/vet-bar.dds', true)
            controls.vetProgBar.Top:Set(controls.roIcon.Top)
            controls.vetProgBar.Bottom:Set(controls.roIcon.Bottom)
            controls.vetProgBar.Left:Set(function() return controls.roIcon.Right() + 1 end)
        end
    end
end
