#
# Aeon Serpentine Missile
#
local AMissileSerpentineProjectile = import('/lua/aeonprojectiles.lua').AMissileSerpentineProjectile

AIFMissileSerpentine01 = Class(AMissileSerpentineProjectile) {
    OnCreate = function(self)
        AMissileSerpentineProjectile.OnCreate(self)
        self:SetCollisionShape('Sphere', 0, 0, 0, 3.0)
        --self:ForkThread(self.CheckTarget,self)
        self:SetTurnRate(30)
        self:ForkThread(self.MovementThread)
    end,

    MovementThread = function(self)
        WaitSeconds(0.5)
        self:SetTurnRate(235)
    end,

--[[
    CheckTarget = function(self)
        while self do
            if not (self:GetTrackingTarget()) then
                #Get New Target
                #LOG("*debug: No Target!!!")
                local unit = self:GetLauncher()
                if unit then
                    local brain = unit:GetAIBrain()
                    #LOG("*debug: Got brain")
                    local units = brain:GetUnitsAroundPoint(categories.AIR, self:GetPosition(),100 , 'Enemy')
                    for k,v in units do
                        #LOG("*debug: Got New Target!")
                        self:SetNewTarget(v)
                        break
                    end
                end
            #else
                #LOG("*debug: Have a target!")
                #LOG("*debug: Target's name is: " ..  self:GetTrackingTarget().GetBlueprint().General.Name)
            end
        WaitSeconds(0.5)
        end
    end,
--]]
}

TypeClass = AIFMissileSerpentine01
