--[[

This is FUBAR - do it some other day... I've lost patience trying to get it to taper the damage off.

do
local OldClass = AIFQuantumWarhead02
AIFQuantumWarhead02 = Class(OldClass) {

    NukeOuterRingEdgeDamage = 0,
    NukeInnerRingEdgeDamage = 0,

    PassData = function(self, Data)
        if Data.NukeOuterRingEdgeDamage then self.NukeOuterRingEdgeDamage = Data.NukeOuterRingEdgeDamage end
        if Data.NukeInnerRingEdgeDamage then self.NukeInnerRingEdgeDamage = Data.NukeInnerRingEdgeDamage end
        OldClass.PassData(self,Data)
    end,




    OuterRingDamage = function(self)
        local myPos = self:GetPosition()


        local EdgeDamage = self.NukeOuterRingDamage * self.NukeOuterRingEdgeDamage
        local StepDamageReduction = (self.NukeOuterRingDamage - EdgeDamage) / math.floor(self.NukeOuterRingTicks / 2)
        local CurrentDamage = self.NukeOuterRingDamage
        local Halfway = math.ceil(self.NukeOuterRingRadius / 2)

        if self.NukeOuterRingTotalTime == 0 then
            DamageArea(self:GetLauncher(), myPos, self.NukeOuterRingRadius, self.NukeOuterRingDamage, 'Normal', true)
        else
            local ringWidth = ((self.NukeOuterRingRadius - Halfway) / self.NukeOuterRingTicks)
            local tickLength = (self.NukeOuterRingTotalTime / self.NukeOuterRingTicks)
            # Since we're not allowed to have an inner radius of 0 in the DamageRing function,
            # I'm manually executing the first tick of damage with a DamageArea function.
            DamageArea(self:GetLauncher(), myPos, Halfway + ringWidth, self.NukeOuterRingDamage, 'Normal', true)
            WaitSeconds(tickLength)
            for i = 2, self.NukeOuterRingTicks do
                CurrentDamage = CurrentDamage - StepDamageReduction
                if CurrentDamage < 0 then CurrentDamage = 0 end
                #print('Damage Ring: MaxRadius:' .. 2*i)
                DamageRing(self:GetLauncher(), myPos, ringWidth * (i - 1), ringWidth * i, CurrentDamage, 'Normal', true)
                WaitSeconds(tickLength)
            end
        end
    end,






    DeathWeaponDamageThread = function(damageRadius, damage, damageType, damageFriendly) 
        -- , DelayBeforeDamage, EdgeDamageRatio, TotalShockwaveTime 
        local DelayBeforeDamage = 5             -- 5 seconds to start damaging 
        local EdgeDamageRatio = .1              -- 1/10th damage at edge 
        local TotalShockwaveTime = 15           -- 15 seconds total after 1st damage 
        LOG("Doing DeathWeaponDamageThread") 
        if damageRadius and damage and DelayBeforeDamage then 
            WaitSeconds(DelayBeforeDamage) 
            local Run1Step = false 
            if not EdgeDamageRatio then 
                Run1Step = true 
            else 
                if EdgeDamageRatio == 1 then 
                    Run1Step = true 
                end 
            end 
            if damageRadius < 2 then 
                Run1Step = true 
            end 
            if Run1Step then 
                LOG("Running damage of " .. damage .. " for radius of " .. damageRadius) 
                DamageArea(self, self:GetPosition(), damageRadius, damage, damageType or 'Normal', damageFriendly or true) 
            else 
                LOG("Running multiple steps") 
                local EdgeDamage = damage * EdgeDamageRatio 
                local HalfWay = math.ceil(damageRadius / 2) 
                local EdgeFloor = math.floor(damageRadius) 
                local StepCount = EdgeFloor - HalfWay 
                local DamageFalloff = damage - EdgeDamage 
                local StepDamage = DamageFalloff / StepCount 
                local ThisDamageRing = HalfWay 
                local StepDelay = 0 
                if TotalShockwaveTime then 
                    StepDelay = TotalShockwaveTime / StepCount 
                end 
                LOG("Now doing " .. StepCount .. " steps.") 
                for i=1,StepCount do 
                    LOG("Step " .. i) 
                    if StepDelay > 0 then 
                        LOG("Waiting " .. StepDelay .. " seconds for next step.") 
                        WaitSeconds(StepDelay) 
                    end 
                    LOG("Running damage of " .. StepDamage .. " for radius of " .. ThisDamageRing) 
                    DamageArea(self, self:GetPosition(), ThisDamageRing, StepDamage, damageType or 'Normal', damageFriendly or true) 
                    DamageRing(self:GetLauncher(), myPos, ringWidth * (i - 1), ringWidth * i, self.NukeOuterRingDamage, 'Normal', true)
                    ThisDamageRing = ThisDamageRing + 1 
                end 
                LOG("Running damage of " .. EdgeDamage .. " for radius of " .. damageRadius) 
                DamageArea(self, self:GetPosition(), damageRadius, EdgeDamage, damageType or 'Normal', damageFriendly or true) 
            end 
        end 
    end, 
}
TypeClass = AIFQuantumWarhead02
end

--]]