do
local OldProjectile = AIFQuantumWarhead03 
AIFQuantumWarhead03 = Class(OldProjectile) { 
    MovementThread = function(self)
        local army = self:GetArmy()
        local target = self:GetTrackingTarget()
        local launcher = self:GetLauncher()
        self:TrackTarget(false)
        WaitSeconds(3)
        self:SetCollision(true)
        WaitSeconds(3)
        self:SetTurnRate(5)
        WaitSeconds(6)
        self:TrackTarget(true)
        self:SetTurnRate(25)
        WaitSeconds(3.5)
        self:SetBallisticAcceleration(10)
        while not self:BeenDestroyed() do
            self:SetTurnRateByDist()
            WaitSeconds(0.5)
        end
    end,
    SetTurnRateByDist = function(self)
        local dist = self:GetDistanceToTarget()
        if dist > 200 and self.MovementTurnLevel < 2 then
            self:SetTurnRate(0)
            self.MovementTurnLevel = 1
        elseif dist > 85 and dist <= 200 and self.MovementTurnLevel < 3 then
            self:SetTurnRate(30)
            self.MovementTurnLevel = 2
        else
            OldProjectile.SetTurnRateByDist(self)
        end
    end,
} 

TypeClass = AIFQuantumWarhead03
end