do

local OldUnit = UAS0304 
UAS0304 = Class(OldUnit) { 

    SurfaceMode = true,
    Moving = false,
    Built = false,

    OnStopBeingBuilt = function(self, builder, layer)
        OldUnit.OnStopBeingBuilt(self, builder, layer)
        self:SetIntelRadius('Radar', 0)
        self:DisableUnitIntel('Radar')
    end,

    OnLayerChange = function(self, new, old)
        if old == "Sub" and new == "Water" then                             -- Surfaced
            local bpIntel = self:GetBlueprint().Intel
            self:SetIntelRadius('Radar', bpIntel.RadarRadius)
            self:EnableUnitIntel('Radar')
        end
        if old == "Water" and new == "Sub" then                             -- Submerged
            self:SetIntelRadius('Radar', 0)
            self:DisableUnitIntel('Radar')
        end
        OldUnit.OnLayerChange(self, new, old)
    end,
} 

TypeClass = UAS0304

end