do

local OldUnit = URL0303
local CWalkingLandUnit = import('/lua/cybranunits.lua').CWalkingLandUnit
URL0303 = Class(OldUnit) {
    Weapons = {
        Disintigrator = Class(CDFLaserDisintegratorWeapon) {
            OnWeaponFired = function(self)
                local bp = self:GetBlueprint()
                if self.unit.RecloakCountdown < (bp.RecloakAfterFiringDelay or 0) then
                    self.unit.RecloakCountdown = bp.RecloakAfterFiringDelay or 0
                end
                CDFLaserDisintegratorWeapon.OnWeaponFired(self)
            end,
        },
        HeavyBolter = Class(CDFElectronBolterWeapon) {
            OnWeaponFired = function(self)
                local bp = self:GetBlueprint()
                if self.unit.RecloakCountdown < (bp.RecloakAfterFiringDelay or 0) then
                    self.unit.RecloakCountdown = bp.RecloakAfterFiringDelay or 0
                end
                CDFElectronBolterWeapon.OnWeaponFired(self)
            end,
        },
        EMP = Class(EMPDeathWeapon) {},
    },
    OnStopBeingBuilt = function(self, builder, layer)
        OldUnit.OnStopBeingBuilt(self, builder, layer) 
        self:SetScriptBit('RULEUTC_IntelToggle', false)
        self:RequestRefreshUI()
        self.RecloakCountdown = 0
        self.CloakManagerThread = self:ForkThread(self.CloakManager)
    end, 
    OnKilled = function(self, instigator, type, overkillRatio)
        CWalkingLandUnit.OnKilled(self, instigator, type, overkillRatio)
    end,
}   
    
TypeClass = URL0303

end
